%global __strip %{mingw_strip}
%global __objdump %{mingw_objdump}
%global _use_internal_dependency_generator 0
%global __find_requires %{mingw_findrequires}
%global __find_provides %{mingw_findprovides}
%define __debug_install_post %{mingw_debug_install_post}

%global mingw_pkg_name tinycc
%global mingw_build_win32 1
%global mingw_build_win64 1
%define tccdir tinycc

Name:           mingw-tinycc
Version:        0.9.26
Release:        0.1.20101220git%{?dist}
Summary:        Tiny C Compiler and C script engine

Group:          Development/Languages
License:        LGPLv2+
URL:            http://www.tinycc.org/
Source0:        http://thenerdshow.com/rpm/tinycc-%{version}.tar.bz2
# Package built from mob branch
# Instructions are at http://repo.or.cz/w/tinycc.git

# git clone git://repo.or.cz/tinycc.git
# git checkout mob

# You should now be updated to latest "mob" branch from:
# http://repo.or.cz/w/tinycc.git/shortlog/refs/heads/mob
# git show

# The archive was built like so:
# rm -rf ../tinycc-0.9.26
# git checkout-index --prefix=../tinycc-0.9.26/ -a
# tar cjf tinycc-0.9.26.tar.bz2 ../tinycc-0.9.26/
Patch1:         mingw-tinycc-mingw32.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildArch:      noarch

BuildRequires:  mingw-filesystem >= 65
BuildRequires:  mingw32-gcc
BuildRequires:  mingw64-gcc
BuildRequires:  texi2html

%description
The Tiny C Compiler is a small, fast compiler that supports C
Scripting and aims to be c99 compliant.

# Mingw32
%package -n mingw32-%{mingw_pkg_name}
Summary:        %{summary}

%description -n mingw32-%{mingw_pkg_name}
The Tiny C Compiler is a small, fast compiler that supports C
Scripting and aims to be c99 compliant.

# Mingw64
%package -n mingw64-%{mingw_pkg_name}
Summary:        %{summary}

%description -n mingw64-%{mingw_pkg_name}
The Tiny C Compiler is a small, fast compiler that supports C
Scripting and aims to be c99 compliant.


%prep
%setup -q -n %{mingw_pkg_name}-%{version}
%patch1 -p1 -b .mingw32

mkdir -p build_win32 build_win64
cp -R `echo * | sed 's/build_win..//g'` build_win32
cp -R `echo * | sed 's/build_win..//g'` build_win64

%build
%{mingw_set_suffix}
pushd build_win32$suffix
%{mingw32_env} ; ./configure \
        --cc=$CC \
        --ar=$AR \
        --host=%{mingw32_host} \
        --build=%_build \
        --target=%{mingw32_target} \
        --prefix=%{mingw32_prefix} \
        --exec-prefix=%{mingw32_exec_prefix} \
        --bindir=%{mingw32_bindir} \
        --sbindir=%{mingw32_sbindir} \
        --sysconfdir=%{mingw32_sysconfdir} \
        --datadir=%{mingw32_datadir} \
        --includedir=%{mingw32_includedir} \
        --libdir=%{mingw32_libdir} \
        --libexecdir=%{mingw32_libexecdir} \
        --localstatedir=%{mingw32_localstatedir} \
        --sharedstatedir=%{mingw32_sharedstatedir} \
        --mandir=%{mingw32_mandir} \
        --infodir=%{mingw32_infodir} \
        --docdir=%{mingw32_docdir} \
        --tccdir=%{tccdir} \
        --enable-mingw32
pwd
popd
pushd build_win64$suffix
%{mingw64_env} ; ./configure \
        --host=%{mingw64_host} \
        --build=%_build \
        --target=%{mingw64_target} \
        --prefix=%{mingw64_prefix} \
        --exec-prefix=%{mingw64_exec_prefix} \
        --bindir=%{mingw64_bindir} \
        --sbindir=%{mingw64_sbindir} \
        --sysconfdir=%{mingw64_sysconfdir} \
        --datadir=%{mingw64_datadir} \
        --includedir=%{mingw64_includedir} \
        --libdir=%{mingw64_libdir} \
        --libexecdir=%{mingw64_libexecdir} \
        --localstatedir=%{mingw64_localstatedir} \
        --sharedstatedir=%{mingw64_sharedstatedir} \
        --mandir=%{mingw64_mandir} \
        --infodir=%{mingw64_infodir} \
        --docdir=%{mingw64_docdir} \
        --tccdir=%{tccdir} \
        --enable-mingw32
popd

#sed -i 's|/usr/local|/usr|g' examples/ex* README tcc-doc.texi
pushd build_win32$suffix
%{mingw32_env} ; make CC="$CC" CFLAGS="$CFLAGS" AR="i686-w64-mingw32-ar"
popd
pushd build_win64$suffix
%{mingw32_env} ; make CC="$CC" CFLAGS="$CFLAGS" AR="x86_64-w64-mingw32-ar"
popd

%install
rm -rf $RPM_BUILD_ROOT
pushd build_win32$suffix
%{mingw32_env} ; make install DESTDIR=$RPM_BUILD_ROOT
popd
pushd build_win64$suffix
%{mingw32_env} ; make install DESTDIR=$RPM_BUILD_ROOT
popd

%clean
rm -rf $RPM_BUILD_ROOT

%files -n mingw32-%{mingw_pkg_name}
%defattr(-,root,root)
%doc COPYING Changelog README TODO VERSION
%{mingw32_bindir}/tcc.exe
%{mingw32_bindir}/tiny_impdef.exe
%{mingw32_bindir}/tiny_libmaker.exe
%{mingw32_includedir}/libtcc.h
%{mingw32_libdir}/%{tccdir}/libtcc1.a
%{mingw32_libdir}/%{tccdir}/include/float.h
%{mingw32_libdir}/%{tccdir}/include/stdarg.h
%{mingw32_libdir}/%{tccdir}/include/stdbool.h
%{mingw32_libdir}/%{tccdir}/include/stddef.h
%{mingw32_libdir}/%{tccdir}/include/tcclib.h
%{mingw32_libdir}/%{tccdir}/include/varargs.h
%{mingw32_mandir}
%{mingw32_docdir}
%{mingw32_infodir}
%{mingw32_libdir}/libtcc.a

%files -n mingw64-%{mingw_pkg_name}
%defattr(-,root,root)
%doc COPYING Changelog README TODO VERSION
%{mingw64_bindir}/tcc.exe
%{mingw64_bindir}/tiny_impdef.exe
%{mingw64_bindir}/tiny_libmaker.exe
%{mingw64_includedir}/libtcc.h
%{mingw64_libdir}/%{tccdir}/libtcc1.a
%{mingw64_libdir}/%{tccdir}/include/float.h
%{mingw64_libdir}/%{tccdir}/include/stdarg.h
%{mingw64_libdir}/%{tccdir}/include/stdbool.h
%{mingw64_libdir}/%{tccdir}/include/stddef.h
%{mingw64_libdir}/%{tccdir}/include/tcclib.h
%{mingw64_libdir}/%{tccdir}/include/varargs.h
%{mingw64_mandir}
%{mingw64_docdir}
%{mingw64_infodir}
%{mingw64_libdir}/libtcc.a


%changelog
* Wed Jun 1 2011 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.9.26-mob
- mob branch rebuild
- Initial package, based on bug #473037
